Index: branches/RWT/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp
===================================================================
--- trunk/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 468)
+++ branches/RWT/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 477)
@@ -107,4 +107,8 @@
   "CC_SEND_XRAM_RSP_INVAL_HEADER",
   "CC_SEND_XRAM_RSP_INVAL_NLINE",
+  "CC_SEND_READ_NCC_INVAL_HEADER",
+  "CC_SEND_READ_NCC_INVAL_NLINE",
+  "CC_SEND_WRITE_NCC_INVAL_HEADER",
+  "CC_SEND_WRITE_NCC_INVAL_NLINE",
   "CC_SEND_WRITE_BRDCAST_HEADER",
   "CC_SEND_WRITE_BRDCAST_NLINE",
@@ -148,4 +152,6 @@
   "READ_DIR_REQ",
   "READ_DIR_LOCK",
+  "READ_IVT_LOCK",
+  "READ_WAIT",
   "READ_DIR_HIT",
   "READ_HEAP_REQ",
@@ -165,4 +171,5 @@
   "WRITE_DIR_REQ",
   "WRITE_DIR_LOCK",
+  "WRITE_IVT_LOCK_HIT_WB",
   "WRITE_DIR_READ",
   "WRITE_DIR_HIT",
@@ -173,4 +180,5 @@
   "WRITE_UPT_DEC",
   "WRITE_RSP",
+  "WRITE_MISS_IVT_LOCK",
   "WRITE_MISS_TRT_LOCK",
   "WRITE_MISS_TRT_DATA",
@@ -215,8 +223,10 @@
   "IXR_CMD_CAS_IDLE",
   "IXR_CMD_XRAM_IDLE",
+  "IXR_CMD_CLEANUP_IDLE",
   "IXR_CMD_READ",
   "IXR_CMD_WRITE",
   "IXR_CMD_CAS",
-  "IXR_CMD_XRAM"
+  "IXR_CMD_XRAM",
+  "IXR_CMD_CLEANUP_DATA"
 };
 const char *cas_fsm_str[] =
@@ -248,7 +258,11 @@
   "CLEANUP_IDLE",
   "CLEANUP_GET_NLINE",
+  "CLEANUP_GET_DATA",
   "CLEANUP_DIR_REQ",
   "CLEANUP_DIR_LOCK",
   "CLEANUP_DIR_WRITE",
+  "CLEANUP_IVT_LOCK_DATA",
+  "CLEANUP_IVT_CLEAR_DATA",
+  "CLEANUP_READ_RSP",
   "CLEANUP_HEAP_REQ",
   "CLEANUP_HEAP_LOCK",
@@ -260,4 +274,6 @@
   "CLEANUP_IVT_CLEAR",
   "CLEANUP_WRITE_RSP",
+  "CLEANUP_IXR_REQ",
+  "CLEANUP_WAIT",
   "CLEANUP_CONFIG_ACK",
   "CLEANUP_SEND_CLACK"
@@ -279,5 +295,6 @@
   "ALLOC_TRT_CAS",
   "ALLOC_TRT_XRAM_RSP",
-  "ALLOC_TRT_IXR_RSP"
+  "ALLOC_TRT_IXR_RSP",
+  "ALLOC_TRT_CLEANUP"
 };
 const char *alloc_upt_fsm_str[] =
@@ -290,4 +307,5 @@
 {
   "ALLOC_IVT_WRITE",
+  "ALLOC_IVT_READ",
   "ALLOC_IVT_XRAM_RSP",
   "ALLOC_IVT_CLEANUP",
@@ -339,4 +357,5 @@
   : soclib::caba::BaseModule(name),
 
+    m_monitor_ok(false),
     p_clk( "p_clk" ),
     p_resetn( "p_resetn" ),
@@ -526,4 +545,10 @@
     r_cas_data                 = new sc_signal<data_t>[nwords];
     r_cas_rdata                = new sc_signal<data_t>[2];
+
+    // Allocation for ODCCP
+    r_cleanup_data             = new sc_signal<data_t>[nwords];
+    r_cleanup_to_ixr_cmd_data  = new sc_signal<data_t>[nwords];
+    r_cleanup_to_tgt_rsp_data  = new sc_signal<data_t>[nwords];
+    r_cleanup_old_data         = new sc_signal<data_t>[nwords];
 
     // Allocation for debug
@@ -641,4 +666,76 @@
 
 /////////////////////////////////////////
+tmpl(void) ::clear_stats()
+/////////////////////////////////////////
+{
+
+    m_cpt_cycles                  = 0;
+    m_cpt_read                    = 0;
+    m_cpt_read_miss               = 0;
+    m_cpt_write                   = 0;
+    m_cpt_write_miss              = 0;
+    m_cpt_write_cells             = 0;
+    m_cpt_write_dirty             = 0;
+    m_cpt_update                  = 0;
+    m_cpt_update_mult             = 0;
+    m_cpt_inval_brdcast           = 0;
+    m_cpt_inval                   = 0;
+    m_cpt_inval_mult              = 0;
+    m_cpt_cleanup                 = 0;
+    m_cpt_ll                      = 0;
+    m_cpt_sc                      = 0;
+    m_cpt_cas                     = 0;
+    m_cpt_trt_full                = 0;
+    m_cpt_trt_rb                  = 0;
+    m_cpt_dir_unused              = 0;
+    m_cpt_ivt_unused              = 0;
+    m_cpt_upt_unused              = 0;
+    m_cpt_heap_unused             = 0;
+    m_cpt_trt_unused              = 0;
+    m_cpt_read_fsm_n_dir_lock     = 0;
+    m_cpt_read_fsm_dir_lock       = 0;
+    m_cpt_read_fsm_dir_used       = 0;
+    m_cpt_read_fsm_trt_lock       = 0;
+    m_cpt_read_fsm_heap_lock      = 0;
+    m_cpt_write_fsm_dir_lock      = 0;
+    m_cpt_write_fsm_n_dir_lock    = 0;
+    m_cpt_write_fsm_upt_lock      = 0;
+    m_cpt_write_fsm_heap_lock     = 0;
+    m_cpt_write_fsm_dir_used      = 0;
+    m_cpt_write_fsm_trt_lock      = 0;
+    m_cpt_cas_fsm_n_dir_lock      = 0;
+    m_cpt_cas_fsm_dir_lock        = 0;
+    m_cpt_cas_fsm_upt_lock        = 0;
+    m_cpt_cas_fsm_heap_lock       = 0;
+    m_cpt_cas_fsm_trt_lock        = 0;
+    m_cpt_cas_fsm_dir_used        = 0;
+    m_cpt_xram_rsp_fsm_n_dir_lock = 0;
+    m_cpt_xram_rsp_fsm_dir_lock   = 0;
+    m_cpt_xram_rsp_fsm_trt_lock   = 0;
+    m_cpt_xram_rsp_fsm_upt_lock   = 0;
+    m_cpt_xram_rsp_fsm_heap_lock  = 0;
+    m_cpt_xram_rsp_fsm_dir_used   = 0;
+    m_cpt_cleanup_fsm_dir_lock    = 0;
+    m_cpt_cleanup_fsm_n_dir_lock  = 0;
+    m_cpt_cleanup_fsm_heap_lock   = 0;
+    m_cpt_cleanup_fsm_ivt_lock    = 0;
+    m_cpt_cleanup_fsm_dir_used    = 0;
+    m_cpt_ixr_fsm_trt_lock        = 0;
+    m_cpt_multi_ack_fsm_upt_lock  = 0;
+    m_cpt_read_data_unc           = 0;   
+    m_cpt_read_data_miss_CC       = 0;   
+    m_cpt_read_ins_unc            = 0;        
+    m_cpt_read_ins_miss           = 0;      
+    m_cpt_read_ll_CC              = 0;       
+    m_cpt_read_data_miss_NCC      = 0;        
+    m_cpt_read_ll_NCC             = 0;    
+    m_cpt_read_WTF                = 0;   
+    m_cpt_cleanup_data            = 0;      
+    m_cpt_ncc_to_cc_read          = 0;      
+    m_cpt_ncc_to_cc_write         = 0;       
+    m_cpt_ncc_to_cc               = 0;        
+}
+
+/////////////////////////////////////////
 tmpl(void) ::print_stats()
 /////////////////////////////////////////
@@ -647,24 +744,86 @@
   std::cout
       << "MEM_CACHE " << name() << " / Time = " << m_cpt_cycles << std::endl
-      << "- READ RATE            = " << (double) m_cpt_read/m_cpt_cycles << std::endl
-      << "- READ TOTAL           = " << m_cpt_read << std::endl
-      << "- READ MISS RATE       = " << (double) m_cpt_read_miss/m_cpt_read << std::endl
-      << "- WRITE RATE           = " << (double) m_cpt_write/m_cpt_cycles << std::endl
-      << "- WRITE TOTAL          = " << m_cpt_write << std::endl
-      << "- WRITE MISS RATE      = " << (double) m_cpt_write_miss/m_cpt_write << std::endl
-      << "- WRITE BURST LENGTH   = " << (double) m_cpt_write_cells/m_cpt_write << std::endl
-      << "- WRITE BURST TOTAL    = " << m_cpt_write_cells << std::endl
-      << "- REQUESTS TRT FULL    = " << m_cpt_trt_full << std::endl
-      << "- READ TRT BLOKED HIT  = " << m_cpt_trt_rb << std::endl
-      << "- UPDATE RATE          = " << (double) m_cpt_update/m_cpt_cycles << std::endl
-      << "- UPDATE ARITY         = " << (double) m_cpt_update_mult/m_cpt_update << std::endl
-      << "- INVAL MULTICAST RATE = " << (double)(m_cpt_inval-m_cpt_inval_brdcast) /m_cpt_cycles << std::endl
-      << "- INVAL MULTICAST ARITY= " << (double) m_cpt_inval_mult/ (m_cpt_inval-m_cpt_inval_brdcast) << std::endl
-      << "- INVAL BROADCAST RATE = " << (double) m_cpt_inval_brdcast/m_cpt_cycles << std::endl
-      << "- SAVE DIRTY RATE      = " << (double) m_cpt_write_dirty/m_cpt_cycles << std::endl
-      << "- CLEANUP RATE         = " << (double) m_cpt_cleanup/m_cpt_cycles << std::endl
-      << "- LL RATE              = " << (double) m_cpt_ll/m_cpt_cycles << std::endl
-      << "- SC RATE              = " << (double) m_cpt_sc/m_cpt_cycles << std::endl
-      << "- CAS RATE             = " << (double) m_cpt_cas/m_cpt_cycles << std::endl;
+      << "- READ RATE                              = " << (double) m_cpt_read/m_cpt_cycles << std::endl
+      << "- READ TOTAL                             = " << m_cpt_read << std::endl
+      << "- READ MISS RATE                         = " << (double) m_cpt_read_miss/m_cpt_read << std::endl
+      << "- WRITE RATE                             = " << (double) m_cpt_write/m_cpt_cycles << std::endl
+      << "- WRITE TOTAL                            = " << m_cpt_write << std::endl
+      << "- WRITE MISS RATE                        = " << (double) m_cpt_write_miss/m_cpt_write << std::endl
+      << "- WRITE BURST LENGTH                     = " << (double) m_cpt_write_cells/m_cpt_write << std::endl
+      << "- WRITE BURST TOTAL                      = " << m_cpt_write_cells << std::endl
+      << "- REQUESTS TRT FULL                      = " << m_cpt_trt_full << std::endl
+      << "- READ TRT BLOKED HIT                    = " << m_cpt_trt_rb << std::endl
+      << "- UPDATE RATE                            = " << (double) m_cpt_update/m_cpt_cycles << std::endl
+      << "- UPDATE ARITY                           = " << (double) m_cpt_update_mult/m_cpt_update << std::endl
+      << "- INVAL MULTICAST RATE                   = " << (double)(m_cpt_inval-m_cpt_inval_brdcast) /m_cpt_cycles << std::endl
+      << "- INVAL MULTICAST ARITY                  = " << (double) m_cpt_inval_mult/ (m_cpt_inval-m_cpt_inval_brdcast) << std::endl
+      << "- INVAL BROADCAST RATE                   = " << (double) m_cpt_inval_brdcast/m_cpt_cycles << std::endl
+      << "- SAVE DIRTY RATE                        = " << (double) m_cpt_write_dirty/m_cpt_cycles << std::endl
+      << "- CLEANUP RATE                           = " << (double) m_cpt_cleanup/m_cpt_cycles << std::endl
+      << "- LL RATE                                = " << (double) m_cpt_ll/m_cpt_cycles << std::endl
+      << "- SC RATE                                = " << (double) m_cpt_sc/m_cpt_cycles << std::endl
+      << "- CAS RATE                               = " << (double) m_cpt_cas/m_cpt_cycles << std::endl << std::endl
+
+      << "- WAIT DIR LOCK in READ_FSM              = " << (double) m_cpt_read_fsm_dir_lock/m_cpt_read_fsm_n_dir_lock << std::endl
+      << "- NB CYCLES IN DIR LOCK in READ_FSM      = " << (double) m_cpt_read_fsm_dir_used/m_cpt_read_fsm_n_dir_lock << std::endl
+      << "- WAIT DIR LOCK in WRITE_FSM             = " << (double) m_cpt_write_fsm_dir_lock/m_cpt_write_fsm_n_dir_lock << std::endl
+      << "- NB CYCLES IN DIR LOCK in WRITE_FSM     = " << (double) m_cpt_write_fsm_dir_used/m_cpt_write_fsm_n_dir_lock << std::endl
+      << "- WAIT DIR LOCK in XRAM_FSM              = " << (double) m_cpt_xram_rsp_fsm_dir_lock/m_cpt_xram_rsp_fsm_n_dir_lock << std::endl
+      << "- NB CYCLES IN DIR LOCK in XRAM_FSM      = " << (double) m_cpt_xram_rsp_fsm_dir_used/m_cpt_xram_rsp_fsm_n_dir_lock << std::endl
+      << "- WAIT DIR LOCK in CLEANUP_FSM           = " << (double) m_cpt_cleanup_fsm_dir_lock/m_cpt_cleanup_fsm_n_dir_lock << std::endl
+      << "- NB CYCLES IN DIR LOCK in CLEANUP_FSM   = " << (double) m_cpt_cleanup_fsm_dir_used/m_cpt_cleanup_fsm_n_dir_lock << std::endl
+      << "- WAIT DIR LOCK in CAS_FSM               = " << (double) m_cpt_cas_fsm_dir_lock/m_cpt_cas_fsm_n_dir_lock << std::endl
+      << "- NB CYCLES IN LOCK in CAS_FSM           = " << (double) m_cpt_cas_fsm_dir_used/m_cpt_cas_fsm_n_dir_lock << std::endl
+      << "- DIR UNUSED RATE                        = " << (double) m_cpt_dir_unused/m_cpt_cycles << std::endl << std::endl
+      
+      << "- WAIT TRT LOCK in READ_FSM              = " << (double) m_cpt_read_fsm_trt_lock/m_cpt_read_fsm_n_trt_lock << std::endl
+      << "- NB CYCLES IN TRT LOCK in READ_FSM      = " << (double) m_cpt_read_fsm_trt_used/m_cpt_read_fsm_n_trt_lock << std::endl
+      << "- WAIT TRT LOCK in WRITE_FSM             = " << (double) m_cpt_write_fsm_trt_lock/m_cpt_write_fsm_n_trt_lock << std::endl
+      << "- NB CYCLES IN TRT LOCK in WRITE_FSM     = " << (double) m_cpt_write_fsm_trt_used/m_cpt_write_fsm_n_trt_lock << std::endl
+      << "- WAIT TRT LOCK in CAS_FSM               = " << (double) m_cpt_cas_fsm_trt_lock/m_cpt_cas_fsm_n_trt_lock << std::endl
+      << "- NB CYCLES IN TRT LOCK in CAS_FSM       = " << (double) m_cpt_cas_fsm_trt_used/m_cpt_cas_fsm_n_trt_lock << std::endl
+      << "- WAIT TRT LOCK in XRAM_FSM              = " << (double) m_cpt_xram_rsp_fsm_trt_lock/m_cpt_xram_rsp_fsm_n_trt_lock << std::endl
+      << "- NB CYCLES IN TRT LOCK in XRAM_FSM      = " << (double) m_cpt_xram_rsp_fsm_trt_used/m_cpt_xram_rsp_fsm_n_trt_lock << std::endl
+      << "- WAIT TRT LOCK in IXR_FSM               = " << (double) m_cpt_ixr_fsm_trt_lock/m_cpt_ixr_fsm_n_trt_lock << std::endl
+      << "- NB CYCLES IN TRT LOCK in IXR_FSM       = " << (double) m_cpt_ixr_fsm_trt_used/m_cpt_ixr_fsm_n_trt_lock << std::endl
+      << "- TRT UNUSED RATE                        = " << (double) m_cpt_trt_unused/m_cpt_cycles << std::endl << std::endl
+      
+      << "- WAIT UPT LOCK in WRITE_FSM             = " << (double) m_cpt_write_fsm_upt_lock/m_cpt_write_fsm_n_upt_lock << std::endl
+      << "- NB CYCLES IN UPT LOCK in WRITE_FSM     = " << (double) m_cpt_write_fsm_upt_used/m_cpt_write_fsm_n_upt_lock << std::endl
+      << "- WAIT UPT LOCK in XRAM_FSM              = " << (double) m_cpt_xram_rsp_fsm_upt_lock/m_cpt_xram_rsp_fsm_n_upt_lock << std::endl
+      << "- NB CYCLES IN UPT LOCK in XRAM_FSM      = " << (double) m_cpt_xram_rsp_fsm_upt_used/m_cpt_xram_rsp_fsm_n_upt_lock << std::endl
+      << "- WAIT UPT LOCK in MULTIACK_FSM          = " << (double) m_cpt_multi_ack_fsm_upt_lock/m_cpt_multi_ack_fsm_n_upt_lock << std::endl
+      << "- NB CYCLES IN UPT LOCK in MULTIACK_FSM  = " << (double) m_cpt_multi_ack_fsm_upt_used/m_cpt_multi_ack_fsm_n_upt_lock << std::endl
+      << "- WAIT UPT LOCK in CLEANUP_FSM           = " << (double) m_cpt_cleanup_fsm_ivt_lock/m_cpt_cleanup_fsm_n_upt_lock << std::endl
+      << "- NB CYCLES IN UPT LOCK in CLEANUP_FSM   = " << (double) m_cpt_cleanup_fsm_ivt_used/m_cpt_cleanup_fsm_n_upt_lock << std::endl
+      << "- WAIT UPT LOCK in CAS_FSM               = " << (double) m_cpt_cas_fsm_upt_lock/m_cpt_cas_fsm_n_upt_lock << std::endl
+      << "- NB CYCLES IN UPT LOCK in CAS_FSM       = " << (double) m_cpt_cas_fsm_upt_used/m_cpt_cas_fsm_n_upt_lock << std::endl
+      << "- UPT UNUSED RATE                        = " << (double) m_cpt_upt_unused/m_cpt_cycles << std::endl << std::endl
+      << "- IVT UNUSED RATE                        = " << (double) m_cpt_ivt_unused/m_cpt_cycles << std::endl << std::endl
+      
+      << "- WAIT HEAP LOCK in READ_FSM             = " << (double) m_cpt_read_fsm_heap_lock/m_cpt_read_fsm_n_heap_lock << std::endl
+      << "- NB CYCLES IN HEAP LOCK in READ_FSM     = " << (double) m_cpt_read_fsm_heap_used/m_cpt_read_fsm_n_heap_lock << std::endl
+      << "- WAIT HEAP LOCK in WRITE_FSM            = " << (double) m_cpt_write_fsm_heap_lock/m_cpt_write_fsm_n_heap_lock << std::endl
+      << "- NB CYCLES IN HEAP LOCK in WRITE_FSM    = " << (double) m_cpt_write_fsm_heap_used/m_cpt_write_fsm_n_heap_lock << std::endl
+      << "- WAIT HEAP LOCK in XRAM_FSM             = " << (double) m_cpt_xram_rsp_fsm_heap_lock/m_cpt_xram_rsp_fsm_n_heap_lock << std::endl
+      << "- NB CYCLES IN HEAP LOCK in XRAM_FSM     = " << (double) m_cpt_xram_rsp_fsm_heap_used/m_cpt_xram_rsp_fsm_n_heap_lock << std::endl
+      << "- WAIT HEAP LOCK in CLEANUP_FSM          = " << (double) m_cpt_cleanup_fsm_heap_lock/m_cpt_cleanup_fsm_n_heap_lock << std::endl
+      << "- NB CYCLES IN HEAP LOCK in CLEANUP_FSM  = " << (double) m_cpt_cleanup_fsm_heap_used/m_cpt_cleanup_fsm_n_heap_lock << std::endl
+      << "- WAIT HEAP LOCK in CAS_FSM              = " << (double) m_cpt_cas_fsm_heap_lock/m_cpt_cas_fsm_n_heap_lock << std::endl
+      << "- NB CYCLES IN HEAP LOCK in CAS_FSM      = " << (double) m_cpt_cas_fsm_heap_used/m_cpt_cas_fsm_n_heap_lock << std::endl
+      << "- HEAP UNUSED RATE                       = " << (double) m_cpt_heap_unused/m_cpt_cycles << std::endl
+
+      << "- READ DATA UNC                          = " << (double) m_cpt_read_data_unc << std::endl
+      << "- READ DATA MISS CC                      = " << (double) m_cpt_read_data_miss_CC << std::endl
+      << "- READ INS UNC                           = " << (double) m_cpt_read_ins_unc << std::endl
+      << "- READ INS MISS                          = " << (double) m_cpt_read_ins_miss << std::endl
+      << "- READ LL CC                             = " << (double) m_cpt_read_ll_CC << std::endl
+      << "- READ DATA MISS NCC                     = " << (double) m_cpt_read_data_miss_NCC << std::endl
+      << "- READ LL NCC                            = " << (double) m_cpt_read_ll_NCC << std::endl
+      << "- READ OTHER                             = " << (double) m_cpt_read_WTF << std::endl
+      << "- CLEANUP + DATA                         = " << (double) m_cpt_cleanup_data << std::endl
+      << "- NCC TO CC READ                         = " << (double) m_cpt_ncc_to_cc_read << std::endl
+      << "- NCC TO CC WRITE                        = " << (double) m_cpt_ncc_to_cc_write << std::endl
+      << "- NCC TO CC                              = " << (double) m_cpt_ncc_to_cc << std::endl;
 }
 
@@ -685,4 +844,9 @@
   delete [] r_write_be;
   delete [] r_write_to_cc_send_data;
+
+  delete [] r_cleanup_data;
+  delete [] r_cleanup_to_ixr_cmd_data;
+  delete [] r_cleanup_to_tgt_rsp_data;
+  delete [] r_cleanup_old_data;
 }
 
@@ -763,4 +927,6 @@
     r_read_to_tgt_rsp_req = false;
     r_read_to_ixr_cmd_req = false;
+    r_read_to_cc_send_req = false;
+    r_read_to_cleanup_req = false;
 
     r_write_to_tgt_rsp_req          = false;
@@ -820,24 +986,90 @@
     r_tgt_rsp_key_sent  = false;
 
+    // ODCCP
+    r_cleanup_data_index       = 0;
+    r_cleanup_trdid            = 0;
+    r_cleanup_pktid            = 0;
+    r_cleanup_contains_data    = false;
+    r_cleanup_ncc              = false;
+    r_cleanup_to_ixr_cmd_ncc_l1_dirty    = false;
+    r_xram_rsp_to_ixr_cmd_inval_ncc_pending    = false;
+    r_cleanup_to_ixr_cmd_req   = false;
+    r_cleanup_to_ixr_cmd_srcid = 0;
+    r_cleanup_to_ixr_cmd_trdid = 0;
+    r_cleanup_to_ixr_cmd_pktid = 0;
+    r_cleanup_to_ixr_cmd_nline = 0;
+    for (size_t word = 0; word < m_words; word ++)
+    {
+      r_cleanup_to_ixr_cmd_data[word] = 0;
+      r_cleanup_data[word] = 0;
+    }
+
+
     // Activity counters
-    m_cpt_cycles        = 0;
-    m_cpt_read          = 0;
-    m_cpt_read_miss     = 0;
-    m_cpt_write         = 0;
-    m_cpt_write_miss    = 0;
-    m_cpt_write_cells   = 0;
-    m_cpt_write_dirty   = 0;
-    m_cpt_update        = 0;
-    m_cpt_update_mult   = 0;
-    m_cpt_inval_brdcast = 0;
-    m_cpt_inval         = 0;
-    m_cpt_inval_mult    = 0;
-    m_cpt_cleanup       = 0;
-    m_cpt_ll            = 0;
-    m_cpt_sc            = 0;
-    m_cpt_cas           = 0;
-    m_cpt_trt_full      = 0;
-    m_cpt_trt_rb        = 0;
-
+    m_cpt_cycles                  = 0;
+    m_cpt_read                    = 0;
+    m_cpt_read_miss               = 0;
+    m_cpt_write                   = 0;
+    m_cpt_write_miss              = 0;
+    m_cpt_write_cells             = 0;
+    m_cpt_write_dirty             = 0;
+    m_cpt_update                  = 0;
+    m_cpt_update_mult             = 0;
+    m_cpt_inval_brdcast           = 0;
+    m_cpt_inval                   = 0;
+    m_cpt_inval_mult              = 0;
+    m_cpt_cleanup                 = 0;
+    m_cpt_ll                      = 0;
+    m_cpt_sc                      = 0;
+    m_cpt_cas                     = 0;
+    m_cpt_trt_full                = 0;
+    m_cpt_trt_rb                  = 0;
+    m_cpt_dir_unused              = 0;
+    m_cpt_upt_unused              = 0;
+    m_cpt_ivt_unused              = 0;
+    m_cpt_heap_unused             = 0;
+    m_cpt_trt_unused              = 0;
+    m_cpt_read_fsm_n_dir_lock     = 0;
+    m_cpt_read_fsm_dir_lock       = 0;
+    m_cpt_read_fsm_dir_used       = 0;
+    m_cpt_read_fsm_trt_lock       = 0;
+    m_cpt_read_fsm_heap_lock      = 0;
+    m_cpt_write_fsm_dir_lock      = 0;
+    m_cpt_write_fsm_n_dir_lock    = 0;
+    m_cpt_write_fsm_upt_lock      = 0;
+    m_cpt_write_fsm_heap_lock     = 0;
+    m_cpt_write_fsm_dir_used      = 0;
+    m_cpt_write_fsm_trt_lock      = 0;
+    m_cpt_cas_fsm_n_dir_lock      = 0;
+    m_cpt_cas_fsm_dir_lock        = 0;
+    m_cpt_cas_fsm_upt_lock        = 0;
+    m_cpt_cas_fsm_heap_lock       = 0;
+    m_cpt_cas_fsm_trt_lock        = 0;
+    m_cpt_cas_fsm_dir_used        = 0;
+    m_cpt_xram_rsp_fsm_n_dir_lock = 0;
+    m_cpt_xram_rsp_fsm_dir_lock   = 0;
+    m_cpt_xram_rsp_fsm_trt_lock   = 0;
+    m_cpt_xram_rsp_fsm_upt_lock   = 0;
+    m_cpt_xram_rsp_fsm_heap_lock  = 0;
+    m_cpt_xram_rsp_fsm_dir_used   = 0;
+    m_cpt_cleanup_fsm_dir_lock    = 0;
+    m_cpt_cleanup_fsm_n_dir_lock  = 0;
+    m_cpt_cleanup_fsm_heap_lock   = 0;
+    m_cpt_cleanup_fsm_ivt_lock    = 0;
+    m_cpt_cleanup_fsm_dir_used    = 0;
+    m_cpt_ixr_fsm_trt_lock        = 0;
+    m_cpt_multi_ack_fsm_upt_lock  = 0;
+    m_cpt_read_data_unc           = 0;   
+    m_cpt_read_data_miss_CC       = 0;   
+    m_cpt_read_ins_unc            = 0;        
+    m_cpt_read_ins_miss           = 0;      
+    m_cpt_read_ll_CC              = 0;       
+    m_cpt_read_data_miss_NCC      = 0;        
+    m_cpt_read_ll_NCC             = 0;    
+    m_cpt_read_WTF                = 0;   
+    m_cpt_cleanup_data            = 0;      
+    m_cpt_ncc_to_cc_read          = 0;      
+    m_cpt_ncc_to_cc_write         = 0;       
+    m_cpt_ncc_to_cc               = 0;        
     return;
   }
@@ -946,4 +1178,5 @@
     if(p_vci_tgt.cmdval)
     {
+
 
 #if DEBUG_MEMC_TGT_CMD
@@ -1106,5 +1339,5 @@
             error            = 0;
             r_config_address = (r_config_address.read() & 0x00000000FFFFFFFFLL) |
-                               ((addr_t)p_vci_tgt.wdata.read())<<32;
+                               ((uint64_t)p_vci_tgt.wdata.read())<<32;
         }
         else if ( (p_vci_tgt.cmd.read() == vci_param_int::CMD_WRITE)   // set buf_lines
@@ -1331,10 +1564,13 @@
     case MULTI_ACK_UPT_LOCK:
     {
+        m_cpt_multi_ack_fsm_upt_lock++;
         // get lock to the UPDATE table
-        if(r_alloc_upt_fsm.read() != ALLOC_UPT_MULTI_ACK) break;
+        if(r_alloc_upt_fsm.read() != ALLOC_UPT_MULTI_ACK)  break;
 
         // decrement the number of expected responses
         size_t count = 0;
         bool valid   = m_upt.decrement(r_multi_ack_upt_index.read(), count);
+
+       /*ODCCP*/ //m_upt.print();
 
         if(not valid)
@@ -1361,4 +1597,5 @@
           << " entry = "       << r_multi_ack_upt_index.read()
           << " / rsp_count = " << std::dec << count << std::endl;
+        m_cpt_multi_ack_fsm_n_upt_lock++;
 #endif
         break;
@@ -1875,4 +2112,6 @@
             << " / nwords = " << std::dec << m_cmd_read_length_fifo.read() << std::endl;
 #endif
+        r_read_coherent = false; //WB by default
+        r_read_ll_done  = false;
         r_read_fsm = READ_DIR_REQ;
       }
@@ -1886,4 +2125,5 @@
       {
         r_read_fsm = READ_DIR_LOCK;
+        m_cpt_read_fsm_n_dir_lock++;
       }
 
@@ -1892,4 +2132,7 @@
 std::cout << "  <MEMC " << name() << " READ_DIR_REQ> Requesting DIR lock " << std::endl;
 #endif
+
+      m_cpt_read_fsm_dir_lock++;
+
       break;
     }
@@ -1903,8 +2146,13 @@
         DirectoryEntry entry =
           m_cache_directory.read(m_cmd_read_addr_fifo.read(), way);
-        // access the global table ONLY when we have an LL cmd
-        if((m_cmd_read_pktid_fifo.read() & 0x7) == TYPE_LL)   
-        {
-          r_read_ll_key   = m_llsc_table.ll(m_cmd_read_addr_fifo.read());
+        if(((m_cmd_read_pktid_fifo.read() & 0x7) == TYPE_LL) and not r_read_ll_done.read())   // access the global table ONLY when we have an LL cmd
+        {
+          addr_t      nline      = m_nline[(addr_t)(m_cmd_read_addr_fifo.read())];
+          r_read_ll_key   = m_llsc_table.ll(nline);
+          //r_read_ll_key   = m_llsc_table.ll(m_cmd_read_addr_fifo.read());
+          /**//*std::cout << "MEMCACHE : from proc " << m_cmd_read_srcid_fifo.read()
+                        << " | @ " << std::hex << m_cmd_read_addr_fifo.read()
+                        << " | LL" << std::endl;*/
+          r_read_ll_done  = true;
         }
         r_read_is_cnt     = entry.is_cnt;
@@ -1926,14 +2174,26 @@
         // TYPE_READ_INS_MISS  0bX011 with TSAR encoding
         bool cached_read = (m_cmd_read_pktid_fifo.read() & 0x1);
+
+
         if(entry.valid)    // hit
         {
-          // test if we need to register a new copy in the heap
-          if(entry.is_cnt or (entry.count == 0) or !cached_read)
+          r_read_coherent = entry.cache_coherent;
+          if (entry.cache_coherent or (entry.count == 0))// or (entry.owner.srcid == m_cmd_read_srcid_fifo.read())) //hit on a WT line or the owner has no more copy (if LL, the owner must be invalidated even if he made the request)
           {
-            r_read_fsm = READ_DIR_HIT;
+            // test if we need to register a new copy in the heap
+            if(entry.is_cnt || (entry.count == 0) || !cached_read)
+            {
+              r_read_fsm = READ_DIR_HIT;
+            }
+            else
+            {
+              //std::cout << "is LL = " << ((m_cmd_read_pktid_fifo.read() & 0x7) == TYPE_LL) << std::endl;
+              //std::cout << "coherent = " << entry.cache_coherent << " | count = " << std::dec << entry.count << " | cached = " << cached_read << std::endl;
+              r_read_fsm = READ_HEAP_REQ;
+            }
           }
-          else
+          else //hit on a WB line owned by an other proc
           {
-            r_read_fsm = READ_HEAP_REQ;
+            r_read_fsm = READ_IVT_LOCK;
           }
         }
@@ -1950,5 +2210,6 @@
           << " / hit = " << std::dec << entry.valid
           << " / count = " <<std::dec << entry.count
-          << " / is_cnt = " << entry.is_cnt;
+          << " / is_cnt = " << entry.is_cnt
+          << " / is_coherent = " << entry.cache_coherent;
 if((m_cmd_read_pktid_fifo.read() & 0x7) == TYPE_LL) std::cout << " / LL access" << std::endl;
 else                                                std::cout << std::endl;
@@ -1965,5 +2226,89 @@
     }
 
+    ///////////////////
+    case READ_IVT_LOCK:
+    {
+      if (r_alloc_ivt_fsm.read() == ALLOC_IVT_READ)
+      {
+        size_t index;
+        addr_t nline = m_nline[(addr_t)(m_cmd_read_addr_fifo.read())];
+        /*std::cout << "nline = " << std::dec <<  nline << std::endl
+                  << "inval en cours sur la ligne = " << m_upt.search_inval(nline, index) << std::endl
+                  << "UPT full = " << m_upt.is_full() << std::endl
+                  << "CC_SEND req = " << r_read_to_cc_send_req.read() << std::endl
+                  << "CLENAUP req = " <<r_read_to_cleanup_req.read() << std::endl;*/
+        if(m_upt.search_inval(nline, index) or m_upt.is_full() or r_read_to_cc_send_req.read() or r_read_to_cleanup_req.read()) //Check pending inval
+        {
+          r_read_fsm = READ_WAIT;
+#if DEBUG_MEMC_READ
+        if(m_debug)
+        {
+          std::cout
+              << "  <MEMC " << name() << " READ_IVT_LOCK>" 
+              << " Wait cleanup completion"
+              << std::endl;
+        }
+#endif
+        }
+        else
+        {
+          r_read_to_cc_send_req = true;
+          r_read_to_cc_send_dest = r_read_copy.read();
+          r_read_to_cc_send_nline = nline;
+          r_read_to_cc_send_inst = ((m_cmd_read_pktid_fifo.read() & 0x2) != 0); 
+          r_read_to_cleanup_req = true;
+          r_read_to_cleanup_nline = nline;
+          r_read_to_cleanup_srcid = m_cmd_read_srcid_fifo.read();
+          r_read_to_cleanup_length  = m_cmd_read_length_fifo.read();
+          r_read_to_cleanup_first_word = m_x[(addr_t) m_cmd_read_addr_fifo.read()];
+          r_read_to_cleanup_cached_read = (m_cmd_read_pktid_fifo.read() & 0x1);
+          r_read_to_cleanup_addr = m_cmd_read_addr_fifo.read();
+          r_read_to_cleanup_is_ll= ((m_cmd_read_pktid_fifo.read() & 0x7) == TYPE_LL);
+          r_read_to_cleanup_ll_key = r_read_ll_key.read();
+          //std::cout << "cleanup req (read) on line " << nline << " /on proc " << r_read_copy.read() << std::endl;
+
+          m_upt.set(false,  // it's an inval transaction
+                          false,     // it's not a broadcast
+                          false,     // it needs a read response
+                          false,     // no acknowledge required
+                          m_cmd_read_srcid_fifo.read(),
+                          m_cmd_read_trdid_fifo.read(),
+                          m_cmd_read_pktid_fifo.read(),
+                          nline,
+                          0x1, //Expect only one answer
+                          index);
+
+          cmd_read_fifo_get = true;
+          r_read_fsm = READ_IDLE;
+#if DEBUG_MEMC_READ
+        if(m_debug)
+        {
+          std::cout
+              << "  <MEMC " << name() << " READ_IVT_LOCK>" 
+              << " Inval req on an NCC line"
+              << std::endl;
+        }
+#endif
+        }
+      }
+
+
+      break;
+    }
+
     //////////////////
+        case READ_WAIT://Release the locks
+        {
+            r_read_fsm = READ_DIR_REQ;
+#if DEBUG_MEMC_READ
+        if(m_debug)
+        {
+          std::cout
+              << "  <MEMC " << name() << " READ_WAIT>" << std::endl;
+        }
+#endif
+        break;
+        }
+    ///////////////////                      
     case READ_DIR_HIT:    //  read data in cache & update the directory
                           //  we enter this state in 3 cases:
@@ -1996,4 +2341,6 @@
         DirectoryEntry entry;
         entry.valid   = true;
+        entry.cache_coherent = r_read_coherent.read() or inst_read or (!(cached_read)) or (r_read_copy.read() != m_cmd_read_srcid_fifo.read());
+        r_read_coherent = r_read_coherent.read() or inst_read or (!(cached_read)) or (r_read_copy.read() != m_cmd_read_srcid_fifo.read());
         entry.is_cnt  = is_cnt;
         entry.dirty   = r_read_dirty.read();
@@ -2001,5 +2348,4 @@
         entry.lock    = r_read_lock.read();
         entry.ptr     = r_read_ptr.read();
-
         if(cached_read)   // Cached read => we must update the copies
         {
@@ -2034,13 +2380,14 @@
 
 #if DEBUG_MEMC_READ
-        if(m_debug)
-          std::cout << "  <MEMC " << name() << " READ_DIR_HIT> Update directory entry:"
-            << " addr = " << std::hex << m_cmd_read_addr_fifo.read()
-            << " / set = " << std::dec << set
-            << " / way = " << way
-            << " / owner_id = " << std::hex << entry.owner.srcid
-            << " / owner_ins = " << std::dec << entry.owner.inst
-            << " / count = " << entry.count
-            << " / is_cnt = " << entry.is_cnt << std::endl;
+if(m_debug)
+std::cout << "  <MEMC " << name() << " READ_DIR_HIT> Update directory entry:"
+          << " addr = " << std::hex << m_cmd_read_addr_fifo.read()
+          << " / set = " << std::dec << set
+          << " / way = " << way
+          << " / owner_id = " << std::hex << entry.owner.srcid
+          << " / owner_ins = " << std::dec << entry.owner.inst
+          << " / coherent = " << entry.cache_coherent
+          << " / count = " << entry.count
+          << " / is_cnt = " << entry.is_cnt << std::endl;
 #endif
 
@@ -2056,4 +2403,5 @@
       {
         r_read_fsm = READ_HEAP_LOCK;
+        m_cpt_read_fsm_n_heap_lock++;
       }
 
@@ -2063,4 +2411,7 @@
           << " Requesting HEAP lock " << std::endl;
 #endif
+
+      m_cpt_read_fsm_heap_lock++;
+
       break;
     }
@@ -2075,4 +2426,9 @@
         bool go_cnt = (r_read_count.read() >= m_max_copies) or m_heap.is_full();
 
+        if (!r_read_coherent.read())
+        {
+          std::cout << "Address = " << std::hex << (m_cmd_read_addr_fifo.read()) << std::dec << " |count = " << r_read_count.read() << std::endl;
+        }
+        assert (r_read_coherent.read() && "accÃšs au heap sur ncc");
         // read data in the cache
         size_t set = m_y[(addr_t)(m_cmd_read_addr_fifo.read())];
@@ -2086,4 +2442,5 @@
         DirectoryEntry entry;
         entry.valid  = true;
+        entry.cache_coherent = r_read_coherent.read();
         entry.is_cnt = go_cnt;
         entry.dirty  = r_read_dirty.read();
